@model Iacoviello_2005_linear begin
	Ŷ[0] = ctoY * ĉ[0] + c1toY * c1̂[0] + c2toY * c2̂[0] + ItoY * Î[0]

	c1̂[0] = c1̂[1] - rr̂[0]

	Î[0] = K̂[-1] + γ * (Î[1] - K̂[0]) + (1 - γ * (1 - δ)) * (Ŷ[1] - X̂[1] - K̂[0]) / ψ + (ĉ[0] - ĉ[1]) / ψ

	q̂[0] = γe * q̂[1] + (1 - γe) * (Ŷ[1] - X̂[1] - ĥ[0]) - rr̂[0] * m * β - (1 - m * β) * (ĉ[1] - ĉ[0]) - fie * (ĥ[0] - ĥ[-1] - γ * (ĥ[1] - ĥ[0]))

	q̂[0] = q̂[1] * γh + (1 - γh) * (ĵ[0] - h2̂[0]) - rr̂[0] * β * m2 + (1 - β * m2) * (c2̂[0] - ω * c2̂[1]) - fih * (h2̂[0] - h2̂[-1] - β2 * (h2̂[1] - h2̂[0]))

	q̂[0] = c1̂[0] + q̂[1] * β + ĵ[0] * (1 - β) + ĥ[0] * ι + h2̂[0] * ι2 - c1̂[1] * β + fih * ((ĥ[0] - ĥ[-1]) * htoh1 + (h2̂[0] - h2̂[-1]) * h2toh1 - (ĥ[1] - ĥ[0]) * β * htoh1 - (h2̂[1] - h2̂[0]) * β * h2toh1)

	b̂[0] = q̂[1] + ĥ[0] - rr̂[0]

	b2̂[0] = q̂[1] + h2̂[0] - rr̂[0]

	Ŷ[0] = η * (Â[0] + ĥ[-1] * υ + K̂[-1] * my) / (η - (1 - υ - my)) - (1 - υ - my) * (X̂[0] + c1̂[0] * α + c2̂[0] * (1 - α)) / (η - (1 - υ - my))

	pî[0] = β * pî[1] - X̂[0] * κ + û[0]

	K̂[0] = Î[0] * δ + K̂[-1] * (1 - δ)

	b̂[0] * btoY = ItoY * Î[0] + ctoY * ĉ[0] + (ĥ[0] - ĥ[-1]) * qhtoY + btoY * R * (R̂[-1] + b̂[-1] - pî[0]) - (1 - s1 - s2) * (Ŷ[0] - X̂[0])

	b2̂[0] * b2toY = c2toY * c2̂[0] + (h2̂[0] - h2̂[-1]) * qh2toY + R * b2toY * (R̂[-1] + b2̂[-1] - pî[0]) - s2 * (Ŷ[0] - X̂[0])

	R̂[0] = (1 - rR) * (1 + rpi) * pî[-1] + (1 - rR) * rY * Ŷ[-1] + R̂[-1] * rR + eR̂[x]

	rr̂[0] = R̂[0] - pî[1]

	ĵ[0] = ρj * ĵ[-1] + eĵ[x]

	û[0] = ρu * û[-1] + eû[x]

	Â[0] = ρA * Â[-1] + eÂ[x]

end


@parameters Iacoviello_2005_linear begin
	β = 0.99

	β2 = 0.95

	γ = 0.98

	j = 0.1

	η = 1.01

	my = 0.3

	υ = 0.03

	ψ = 2

	δ = 0.03

	fie = 0

	fih = 0

	X = 1.05

	thη = 0.75

	α = 0.64

	m = 0.89

	m2 = 0.55

	ρu = 0.59

	ρj = 0.85

	ρA = 0.03

	σu = 0.17

	σj = 24.89

	σA = 2.24

	σR = 0.29

	rR = 0.73

	rpi = 0.27

	rY = 0.13

	γe = (1-m)*γ+m*β

	γh = β2+m2*(β-β2)

	ω = (β2-β2*m2)/(1-β*m2)

	κ = (1-thη)*(1-β*thη)/thη

	s1 = (α*(1-my-υ)+X-1)/X

	s2 = (1-my-υ)*(1-α)/X

	qhtoY = γ*υ/(X*(1-γe))

	btoY = m*β*qhtoY

	qh1toY = j*s1/(1-β)+qhtoY*m*j+m2*j*s2/(1-β2-m2*(β-β2-j*(1-β)))

	qh2toY = j*s2/(1-β2-m2*(β-β2-j*(1-β)))

	c1toY = s1+(1-β)*(m*qhtoY+m2*qh2toY)

	htoh1 = qhtoY/qh1toY

	h2toh1 = qh2toY/qh1toY

	b2toY = s2*m2*β*j/(1-β2-m2*(β-β2)+(1-β)*m2*j)

	c2toY = s2*(1-β2-m2*(β-β2))/(1-β2-m2*(β-β2)+(1-β)*m2*j)

	ctoY = (my+υ-my*γ*δ/(1-γ*(1-δ))-qhtoY*X*m*(1-β))/X

	ItoY = 1-ctoY-c1toY-c2toY

	ι = (1-β)*htoh1

	ι2 = (1-β)*h2toh1

	R = 1/β

end

